package io.gitlab.jfronny.libjf.config.impl.ui.tiny;

import io.gitlab.jfronny.commons.tuple.Tuple;
import io.gitlab.jfronny.libjf.LibJf;
import io.gitlab.jfronny.libjf.config.api.v1.EntryInfo;
import io.gitlab.jfronny.libjf.config.api.v1.ui.tiny.WidgetFactory;
import net.minecraft.client.gui.widget.TextFieldWidget;
import net.minecraft.text.Text;

import java.util.List;

public class WidgetState<T> {
    public EntryInfo<T> entry;
    public List<WidgetState<?>> knownStates;

    public Tuple<TextFieldWidget, Text> error;
    public boolean inLimits = true;
    public String tempValue;
    public T cachedValue;
    public WidgetFactory factory;

    public void initialize(EntryInfo<T> entry, List<WidgetState<?>> knownStates, WidgetFactory factory) {
        this.entry = entry;
        this.knownStates = knownStates;
        this.factory = factory;
        updateCache();
    }

    public void updateCache() {
        try {
            updateCache(entry.getValue());
        } catch (IllegalAccessException e) {
            LibJf.LOGGER.error("Could not set widget state cache to current value", e);
        }
    }

    public void updateCache(T newValue) {
        cachedValue = newValue;
        tempValue = newValue == null ? null : newValue.toString();
    }

    public void writeToEntry() throws IllegalAccessException {
        entry.setValue(cachedValue);
    }

    public void reset() {
        cachedValue = entry.getDefault();
    }
}
