package io.gitlab.jfronny.libjf.data.manipulation.api;

import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Identifier;

import java.util.HashSet;
import java.util.Set;

@SuppressWarnings("unused")
public class RecipeUtil {
    private static final Set<Identifier> REMOVAL_BY_ID = new HashSet<>();
    private static final Set<ItemStack> RECIPES_FOR_REMOVAL = new HashSet<>();

    public static void removeRecipe(Identifier identifier) {
    	REMOVAL_BY_ID.add(identifier);
    }

    public static void removeRecipeFor(Item product) {
        RECIPES_FOR_REMOVAL.add(product.getDefaultStack());
    }

    public static boolean isIdBlocked(Identifier identifier) {
    	return REMOVAL_BY_ID.contains(identifier);
    }
    
    public static boolean isOutputBlocked(ItemStack product) {
    	for (ItemStack stack : RECIPES_FOR_REMOVAL) {
        	if (product.isItemEqual(stack)) {
        		return true;
        	}
    	}
    	return false;
    }
}
