package io.gitlab.jfronny.libjf.web.impl;

import io.gitlab.jfronny.libjf.LibJf;
import io.gitlab.jfronny.libjf.config.api.v1.*;
import io.gitlab.jfronny.libjf.config.api.v1.dsl.DSL;

import java.io.IOException;
import java.net.ServerSocket;

public class JfWebConfig implements JfCustomConfig {
    public static String serverIp = "http://127.0.0.1";
    public static int port = 0;
    public static int portOverride = -1;
    public static int maxConnections = 20;
    public static boolean enableFileHost = false;

    public static void ensureValidPort() {
        if (port == 0) {
            try (ServerSocket socket = new ServerSocket(0)) {
                port = socket.getLocalPort();
            } catch (IOException e) {
                LibJf.LOGGER.error("Could not bind port to identify available", e);
            }
            ConfigHolder.getInstance().getRegistered().get("libjf-web-v0").write();
        }
    }

    @Override
    public void register(DSL.Defaulted dsl) {
        dsl.register(b -> b
                .value("serverIp", serverIp, () -> serverIp, v -> serverIp = v)
                .value("port", port, 0, 35535, () -> port, v -> port = v)
                .value("portOverride", portOverride, -1, 35535, () -> portOverride, v -> portOverride = v)
                .value("maxConnections", maxConnections, 8, 64, () -> maxConnections, v -> maxConnections = v)
                .value("enableFileHost", enableFileHost, () -> enableFileHost, v -> enableFileHost = v)
        );
    }
}
